/* 4th order Runge-Kutta routine */

#include "ode.h"

rk4(yin,x,h,yout)
double yin[NDOF], yout[NDOF], h, x;
{
 int i;
 double xh, hh, h6, k1[NDOF], k2[NDOF], k3[NDOF], k4[NDOF], yt[NDOF];

 hh = h * 0.5;
 h6 = h / 6.0;
 xh = x + hh;
 derivs(x,yin,k1);
 for(i = 0; i<NDOF; i++) yt[i] = yin[i] + hh * k1[i];
 derivs(xh,yt,k2);
 for(i = 0; i<NDOF; i++) yt[i] = yin[i] + hh * k2[i];
 derivs(xh,yt,k3);
 for(i = 0; i<NDOF; i++) yt[i] = yin[i] + h * k3[i];
 derivs(x + h,yt,k4);
 for(i = 0; i<NDOF; i++)
    yout[i] = yin[i] + h6*(k1[i] + k4[i] + 2.0*(k2[i] + k3[i]));
}

